#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#TEMPLATE (GWBFBW, 'GWB Frame Background Window'),FAMILY('ABC')
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! MAINTENANCE
#! Created by Geoff Bomford for Clarion Magazine article May 13, 2005
#! www.comformark.com.au
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#PROCEDURE(GWBFBS,'GWB Frame Background Source'),WINDOW  #! Frame Background Source procedure
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#COMMENT(60)                                     #! Align comments starting at column 60
#PROMPT('Parameters',@s255),%Parameters          #! Retrieve parameters used
#BOXED('Procedure Properties'),AT(10,,180)
#PROMPT('Generate Open/Close Files Routines',CHECK),%GenerateOpenClose,DEFAULT(%False),AT(10)
#Enable(%GenerateOpenClose=1)
  #PROMPT('Generate Save/Restore Files Routines',CHECK),%GenerateSaveRestore,DEFAULT(%False),AT(10)
#EndEnable
#ENDBOXED
#!-----------------------------------------------------------------------------------
#BOXED('GWB Frame Background Window'),AT(10,,180)
  #DISPLAY()
  #PROMPT('Include ''EnableWindow'' API call?',CHECK),%GWBIncludeDisableWindowAPI,DEFAULT(1),AT(12)
  #DISPLAY('The Frame Background Window will automatically open and close.'),AT(12,,170,20)
  #DISPLAY('This procedure MUST be STARTed.'),AT(12,,170,10)
  #DISPLAY('The THREAD number is saved in the global variable GWBFrameBackgroundThread.'),AT(12,,170,20)
  #DISPLAY('You can POST(EVENT:User,,GWBFrameBackgroundThread) to this Frame Background thread.'),AT(12,,170,25)
  #DISPLAY()
#ENDBOXED
#!-----------------------------------------------------------------------------------
#IF(%Parameters)                                  #! IF Parameters used
%[20]Procedure PROCEDURE  %Parameters                           #<! Declare Procedure
#ELSE                                             #! ELSE (IF parameters not used)
%[20]Procedure PROCEDURE                                        #<! Declare Procedure
#ENDIF                                            #! END (IF parameters used)
#!#EMBED(%GatherSymbols,'Gather Template Symbols'),HIDE
#INSERT(%FileControlInitialize(ABC))
#!-----------------------------------------------------------------------------------
#! Include the Windows API call in the Global Map embed
#!#IF(%GWBIncludeDisableWindowAPI = 1)
  #AT(%GlobalMap),PRIORITY(4000), WHERE(%GWBIncludeDisableWindowAPI = 1)
   MODULE('GWBFBW_Template')
    GWBDisableWindow(USHORT,SHORT Enabled=False),PASCAL,NAME('EnableWindow')
   END
  #ENDAT
#!#ENDIF
#!-----------------------------------------------------------------------------------
#! Declare a Global Variable, place it in the Global Data list so developers can access it
#GLOBALDATA
GWBFrameBackgroundThread  LONG
#ENDGLOBALDATA
#!-----------------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
#ENDAT
#FOR(%LocalData)
%[20]LocalData %LocalDataStatement  #<!%LocalDataDescription
#ENDFOR
#AT(%DataSection),PRIORITY(5000),DESCRIPTION('Window Structure')
#SUSPEND
#MESSAGE('Standard Window Generation',3)
#EMBED(%DataSectionBeforeWindow,'Data Section, Before Window Declaration'),DATA,LEGACY
#!-----------------------------------------------------------------------------------
#! Add the window structure to the source procedure.
#! I start with a basic DEFAULT window, and allow the developer to edit the window,
#! but, make sure there are no menus, toolbars or buttons in the window.
#! Make sure the window is MDI - or won't be able to exit the app <g>
#!
#DECLARE(%GWBWindowAt)
#DECLARE(%GWBWindowStatement)
#DECLARE(%GWBIndentation)
#DECLARE(%GWBTimerPresent)
  #SET(%GWBWindowAt, EXTRACT(%WindowStatement,'AT'))
  #SET(%GWBWindowStatement,'WINDOW,' & %GWBWindowAt)
  #IF(EXTRACT(%WindowStatement,'FONT'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'FONT'))
  #ENDIF
  #IF(EXTRACT(%WindowStatement,'COLOR'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'COLOR'))
  #ENDIF
  #IF(EXTRACT(%WindowStatement,'WALLPAPER'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'WALLPAPER'))
  #ENDIF
  #IF(EXTRACT(%WindowStatement,'TILED'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'TILED'))
  #ENDIF
  #IF(EXTRACT(%WindowStatement,'CENTER'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'CENTER'))
  #ENDIF
  #IF(EXTRACT(%WindowStatement,'TIMER'))
    #SET(%GWBWindowStatement,%GWBWindowStatement & ',' & EXTRACT(%WindowStatement,'TIMER'))
    #SET(%GWBTimerPresent,1)
  #ENDIF
  #SET(%GWBWindowStatement,%GWBWindowStatement & ',MDI')
%[20]Window %GWBWindowStatement
  #SET(%GWBIndentation,0)
  #DECLARE(%GWBControlSourceLine)
  #FOR(%Control)
    #IF(%ControlIndent<%GWBIndentation)
      #LOOP
        #SET(%GWBIndentation,%GWBIndentation-1)
%[22+(2*%GWBIndentation)]Null END
        #IF(%ControlIndent=%GWBIndentation)
          #BREAK
        #ENDIF
      #ENDLOOP
    #ENDIF
    #SET(%GWBControlSourceLine,%ControlStatement)
    #CASE(%ControlType)
    #OF('MENU')
    #OROF('MENUBAR')
    #OROF('TOOLBAR')
    #OROF('BUTTON')
    #OROF('ITEM')
    #OF('OPTION')
    #OROF('GROUP')
    #OROF('SHEET')
    #OROF('TAB')
    #OROF('OLE')
%[22+(2*%GWBIndentation)]Null %GWBControlSourceLine
      #SET(%GWBIndentation,%GWBIndentation+1)
    #ELSE
%[22+(2*%GWBIndentation)]Null %GWBControlSourceLine
    #ENDCASE
  #ENDFOR
  #LOOP,WHILE(%GWBIndentation)
    #SET(%GWBIndentation,%GWBIndentation-1)
%[22+(2*%GWBIndentation)]Null END
  #ENDLOOP
%[20]Null END
#EMBED(%DataSectionAfterWindow,'Data Section, After Window Declaration'),DATA,LEGACY
#?
#RESUME
#ENDAT
#!--------------------------------------
#EMBED(%DataSection,'Data Section'),DATA,TREE('Local Data{{PRIORITY(1000)}')          #! Embedded Source Code
  CODE
#EMBED(%ProcessedCode,'Processed Code')     #! Embedded Source Code
#!-----------------------------------------------------------------------------------
#AT(%ProcessedCode),PRIORITY(4999)
#!--------------------------------------
  IF GlobalErrors.GetProcedureName() <> ''         #<! GWBFBW - If the Global Errors Procedure Name has been set, it must have been set in the calling thread
    MESSAGE('The Procedure ''%Procedure'' should have been STARTed, it won''t be displayed!','Error',Icon:Exclamation)
    RETURN
  ELSE
    GlobalErrors.SetProcedureName('%Procedure')     #<! GWBFBW - Set the procedure name for this procedure
  END
  GWBFrameBackgroundThread = THREAD()             #<! GWBFBW - Call before opening the window, or it's too late, the Windows API won't do what we want
  #EMBED(%BeforeOpenWindow,'Before Open Window')  #! Allow source code before opening the window
  OPEN(%Window)
  #EMBED(%AfterOpenWindow,'After Open Window')  #! Allow source code after opening the window
  GWBDisableWindow(%Window{PROP:Handle})   #<! Call the api to disable the window
  #EMBED(%AfterDisableWindow,'After Disable Window')  #! Allow source code after Disabling the window
  ACCEPT
    CASE EVENT()
    #EMBED(%CaseEventTop,'CASE EVENT() Top')
    OF Event:CloseWindow
      BREAK
    #SUSPEND
    #IF(%GWBTimerPresent)
    OF Event:Timer
      #EMBED(%GWBTimerEvent,'Case Event Timer')
    #ENDIF
    #?
    #RESUME
    #EMBED(%CaseEventBottom,'CASE EVENT() Bottom')     #! Embedded Source Code
    END
  END
  CLOSE(%Window)
#ENDAT
#!-----------------------------------------------------------------------------------
#EMBED(%ProcedureRoutines,'Procedure Routines'),DATA,LABEL
#EMBED(%LocalProcedures,'Local Procedures'),DATA,LABEL
#INSERT(%LocalMapCheck(ABC))
#!--------------------------------------
#AT(%DataSection),WHERE(%GenerateOpenClose)
#!--------------------------------------
FilesOpened     BYTE(0)
#ENDAT
#AT(%DataSection),WHERE(%GenerateSaveRestore)
  #FOR(%OtherFiles)
%OtherFiles::State  USHORT
  #ENDFOR
#ENDAT
#!--------------------------------------
#AT(%ProcedureRoutines),WHERE(%GenerateSaveRestore)
#!--------------------------------------
SaveFiles  ROUTINE
#MESSAGE('File Control Save Code',3)
#EMBED(%BeforeFileSave,'Beginning of Procedure, Before Saving Files')
#FOR(%OtherFiles)
  %OtherFiles::State = Access:%OtherFiles.SaveFile()            #<! Save File referenced in 'Other Files' so need to inform it's FileManager
#ENDFOR
#EMBED(%AfterFileSave,'End of Procedure, After Saving Files')
  EXIT

#!--------------------------------------
RestoreFiles  ROUTINE
#MESSAGE('File Control Restore Code',3)
#EMBED(%BeforeFileSave,'Beginning of Procedure, Before Restoring Files')
#FOR(%OtherFiles)
  IF %OtherFiles::State <> 0
    Access:%OtherFiles.RestoreFile(%OtherFiles::State)            #<! Restore File referenced in 'Other Files' so need to inform it's FileManager
  END
#ENDFOR
#EMBED(%AfterFileRestore,'End of Procedure, After Restoring Files')
  EXIT

#ENDAT
#!--------------------------------------
#AT(%ProcedureRoutines),WHERE(%GenerateOpenClose)
#!--------------------------------------
OpenFiles  ROUTINE
#MESSAGE('File Control Open Code',3)
#EMBED(%BeforeFileOpen,'Beginning of Procedure, Before Opening Files')
#FOR(%OtherFiles)
  Access:%OtherFiles.Open                                         #<! Open File referenced in 'Other Files' so need to inform it's FileManager
  Access:%OtherFiles.UseFile                                      #<! Use File referenced in 'Other Files' so need to inform it's FileManager
#ENDFOR
  FilesOpened = True
#EMBED(%AfterFileOpen,'Beginning of Procedure, After Opening Files')
  EXIT

#!--------------------------------------
CloseFiles ROUTINE
  #EMBED(%BeforeFileClose,'End of Procedure, Before Closing Files')
  IF FilesOpened THEN
#FOR(%OtherFiles)
     Access:%OtherFiles.Close
#ENDFOR
     FilesOpened = False
  END
  #EMBED(%AfterFileClose,'End of Procedure, After Closing Files')
  EXIT

#ENDAT
#!
#!
#!--------------------------------------
#!
#DEFAULT
NAME GWBFrameBackgroundSourceProcedure
[COMMON]
DESCRIPTION 'Frame Background Source Procedure'
FROM GWBFBW GWBFBS
[WINDOW]
BackWindow WINDOW,AT(0,0,640,480),FONT('Comic Sans MS',8,,FONT:regular,CHARSET:ANSI),COLOR(COLOR:White), |
         TILED,MAXIMIZE,DOUBLE,MDI
       STRING('This is my Application!'),AT(41,41,182,10),USE(?String2),CENTER,#ORIG(?String2)
       PANEL,AT(10,71,267,143),FILL(COLOR:Silver),BEVEL(-2,3)
       STRING('Created with Clarion!'),AT(47,138,182,10),USE(?String1),CENTER,#ORIG(?String1)
     END
#ENDDEFAULT
#!
#!--------------------------------------
#!
